#include"kraluk.h"

#define JEZI_START_X    74
#define JEZI_START_Y    87
#define JEZI_DOLET_X    70
#define JEZI_DOLET_Y    70

static void otevridvere()
{
  vytvorwidget(124, 79, 86, nactikqXPM("zachaldver", 1), 1, 0);
  vytvorwidget(125, 79, 92, nactikqXPM("otvchaldver", 1), 1, 0);
  vytvorsubmap(60, 87, 1, "perdvere", 1, 0);
}

void startjezi()
{
  jezibaba =  vytvorpost(JEZI_START_X, JEZI_START_Y, VLEVO, 2, -1, -1, 1);
  jezibaba->zdi = jezibaba->barvy = 0;
  jezibaba->lokalni = 0;
  jezibaba->chyt_func = jezichyt;
  jezichytej();
  vytvortimer(continuejezi, pinnull, 22, 0, 1, 1, 0);
  zmenanip(jezibaba, jezianip);
  autopost(jezibaba, &auto_clever, 0, 0);
  normal_z(jezibaba, NULL, NULL);
  pol_prichfunc = jeziprichpol;
  otevridvere();
}

void jeziprichpol(kq_policko *odch, int smer, kq_policko *prich)
{
  int i, x, y;

  if(jezibaba->animace == jezileti){
    if(prich == skala1 || prich == skala2 || prich == skala3) normal_z(jezibaba, NULL, NULL);
    else post_z(jezibaba, 0,0,200);
    if(jezibaba->hide){
      i = zjistitimer(jezitimer);
      if(smer == NAHORU) i += 224;
      if(smer == DOLU) i -= 224;
      if(i >= 0) zmentimer(jezitimer, i, jezitimer->priorita);
      else{
	znictimer(jezitimer);
	jezitimer = NULL;
	jezibaba->x = panacek->x;
	jezibaba->y = -i/2-1;
	if(odch != skala2) jezibaba->y = mapa.vyska - jezibaba->y;
	unhidepost(jezibaba);
	if(mappixel(mapa, jezibaba->x, jezibaba->y) == ohen) jezishor();
	if(jezibaba->auto_func != &auto_primo){
	  jezibaba->auto_func = &auto_primo;
	  popup_info("jezi nevzdala");
	}
      }
    }
    else{
      if(prich == skala2) i = mapa.vyska-jezibaba->y;
      else i = jezibaba->y;
      jezitimer = vytvortimer(continuejezi, pinnull, 2*i, -1, 1, 0, 0);
      osoba->kontext--;
      jezislovo->kontext--;
      jezibaba->hide = 1;
    }
    return;
  }

  if(prich != jezilastpol && jezibaba->hide){
    jezil_x = jezibaba->x;
    jezil_y = jezibaba->y;
  }
  else{
    osoba->kontext--;
    jezislovo->kontext--;
  }
  jezibaba->hide = 1;

  if(prich == skal_zebr1){
    jezilastpol = odch;
    return;
  }
  if(prich == skal_zebr2){
    popup_info("nehoupa zebr");
    zmenanip(jezibaba, jezileti);
    jezibaba->chyt_vzdal = 7;
    jezichytej();
    jezibaba->barvy = 1;
    jezilastpol = NULL;
    jezitimer = vytvortimer(continuejezi, pinnull, 400, -1, 1, 0, 0);
    return;
  }
  if(prich == pol[1][1]) otevridvere();

  if(smer == NAHORU) i = jezibaba->y;
  else if(smer == DOLU) i = mapa.vyska-jezibaba->y-1;
  else if(smer == VLEVO) i = jezibaba->x;
  else if(smer == VPRAVO) i = mapa.sirka-jezibaba->x-1;

  if(prich == jezilastpol){
    getchytsour(jezibaba, &x, &y);
    posunpost(jezibaba, x, y);
    unhidepost(jezibaba);
    return;
  }

  posunpost(jezibaba, panacek->x, panacek->y);

  jezilastpol = odch;

  vytvortimer(continuejezi, pinnull, i*2, -1, 1, 1, 0);
}

void continuejezi()
{
  if(!panacek) return;

  if(aktupol == skal_zebr1 || aktupol == skal_zebr2) post_z(jezibaba, 0, 0, 200);
  else normal_z(jezibaba, NULL, NULL);

  if(jezibaba->hide){
    osoba->kontext++;
    jezislovo->kontext++;
  }

  if(jezitimer){
    jezitimer = NULL;
    if(aktupol == skala3){
      jezibaba->x = 85;
      jezibaba->y = 108;
    }
    else{
      jezibaba->x = panacek->x;
      if(aktupol == skala2) jezibaba->y = 0;
      else jezibaba->y = mapa.vyska-1;
    }
    unhidepost(jezibaba);
    if(mappixel(mapa, jezibaba->x, jezibaba->y) == ohen){
      jezishor();
      return;
    }
    if(jezibaba->auto_func != &auto_primo){
      jezibaba->auto_func = &auto_primo;
      popup_info("jezi nevzdala");
    }
    return;
  }
  jezil_x = jezibaba->x;
  jezil_y = jezibaba->y;
  unhidepost(jezibaba);
  jezilastpol = NULL;
}

void jezichyt(kq_postava *jezi)
{
  int x, y;

  if(mappixel(mapa, jezibaba->x, jezibaba->y) == ohen) return;
  if(panacek){
    jezi->lokalni = 0;
    jezi->tim->lokalni = 0;
    jezi->widget->lokalni = 0;
    popup_info("jezichyt");
    znicpost(panacek);
    ovlpost = panacek = NULL;
    if(jezibaba->animace == jezileti){
      jezil_x = jezibaba->x;
      jezil_y = 0;
      post_z(jezibaba, 0, 0, jezibaba->widget->z);
      jezibaba->xx = 0;
      jezibaba->yy = -1;
      autopost(jezibaba, NULL, 0, 0);
      jezibaba->barvy = 0;
    }
  }

  if(jezibaba->animace == jezianip){
    x = JEZI_START_X;
    y = JEZI_START_Y;
  }
  else{
    x = JEZI_DOLET_X;
    y = JEZI_DOLET_Y;
  }

  if(aktupol == pol[1][1]){
    jezil_x = x;
    jezil_y = y;
    if(jezi->x == jezil_x && jezi->y == jezil_y){
      znicpost(jezi);
      jezinull();
      znicwidget(prvwidget);
      znicwidget(prvwidget);
      return;
    }
  }
  else if(jezi->x == jezil_x && jezi->y == jezil_y){
    autopost(jezi, NULL, 0, 0);
    jezil_x = x;
    jezil_y = y;
    if(jezibaba->animace == jezileti){
      jezi->xx = 0;
      jezi->yy = 1;
      post_z(jezi, 0,0, JEZI_START_Y+0.5);
      kql_square(jezi, pol[1][1], x, 0,0,0,0);
    }
    else{
      jezi->xx = 1;
      jezi->yy = 0;
      kql_square(jezi, pol[1][1], 0, y, 0,0,0);
    }
    otevridvere();
  }

  setchytsour(jezibaba, jezil_x, jezil_y);
  jezibaba->chyt_vzdal = 0;
}

void jezicekej ()
{
  setchytsour(jezibaba, 88, 52);
  jezibaba->chyt_vzdal = 0;
}

void jezichytej ()
{
  setchytpost(jezibaba, panacek);
  jezibaba->chyt_vzdal = 7;
}

void houpejzebr ()
{
  vytvortimer(houp_step,
	      pinpointer(vytvorwidget(85, 0, 0, nactikqXPM("houpzebr", 1), 1, 0)),
	      2, 1, 0, 1, 0);
  vytvorsubmap(0, 0, 5, "houpzebr", 1, 0);
  popup_info("houpa zebr");
}

void houp_step (kq_widget *wzebr)
{
  int y;

  if(!prvpost){
    popup_info("co jezi");
    znicwidget(prvwidget);
    vytvorwidget(94, 0, 0, nactikqXPM("zebrik", 1), 1, 0);
    znictimer(aktutimer);
    return;
  }

  y = wzebr->y+5;
  if(y > 0) y -= 150;

  posunwidget(wzebr, wzebr->x, y);
  prvsubmap->y = y;
  reloadmap();
  if(panacek && aktupixel() == skalopad3)
    skalopada(panacek, NULL, NULL);
}

void jezishor ()
{
  osoba->kontext--;
  jezislovo->kontext--;
  popup_info("jezi shor");
  znicpost(jezibaba);
  jezinull();
}

void jezivzdej ()
{
  autopost(jezibaba, NULL, 0, 0);
  if(jezibaba->hide) return;
  post_z(jezibaba, 0, 0, jezibaba->widget->z);
  jezibaba->barvy = 0;
  jezibaba->xx = 0;
  jezibaba->yy = -1;
  setchytsour(jezibaba, 0,0);
  jezibaba->chyt_func = NULL;
  jezibaba->widget->lokalni = jezibaba->tim->lokalni = jezibaba->lokalni = 1;
  jezinull();
}

void jezinull ()
{
  jezibaba = NULL;
  jezilastpol = NULL;
  pol_prichfunc = NULL;
  jezil_x = jezil_y = 0;
}
