//: include

#include <X11/xpm.h>
#include <X11/extensions/shape.h>

//: define

#define PIX_VYS ibarvy->height
#define PIX_SIR ibarvy->width

//: struktura

struct kq_pixmap{
  Pixmap barvy;  // pixmapa
  Pixmap akanal; // pixmapa masky

  XImage *ibarvy; // ximage
  XImage *ikanal; // ximage masky

  int scaled;
  char lokalni;
  char *nazev;
  kq_pixmap *next;
  unsigned int cislo;
};

kq_pixmap *prvpix;

//: fixpix

kq_pixmap *fixed_pixmaps;
int pocet_fixpix;

//: ratio

int ratio;

//: prototypy

Pixmap nactiXPM(char *filename, XImage **xim, Pixmap *shape, XImage **xish);
   /* Nacte XPM file bez pouziti struktury kq_XPM.
      Parametry krome filename jsou nepovinne (mohou byt NULL) */

void rescalePixmap(XImage *ximage, Pixmap *pxm);
   // Prescaluje Image do pixmapy

kq_pixmap *nactikqXPM(char *filename, char lokalni);
   // Nacte XPM file do struktury kq_pxm

void freekqPixmap(kq_pixmap *pxm);
   // Odallokuje kq_pxm

void deletelpixmaps();
   // Odallokuje lokalni pixmapy

void deleteApixmaps();
   // Odallokuje vsechny pixmapy

void fix_pix(); // Zafixuje nactene pixmapy
